//************************************************************
//   File name: VirtualDog.java
//   Reference: Chapter 15
//************************************************************
//
//   Java program to demonstrate a classes and objects
//   Topics:
//      1. Java application with multiple classes
//      2. Object instantiation
//
//   Note:
//      1. Only one class in a file can be public. The public
//         class must have the name of the Java source file.
//      2. The "this" operator refers to the current object.
//      3. Class variables are usually declared with pivate
//         accesibility in order to preserve encapsulation 

//***********************************
//***********************************
//        CLASS Dog
//***********************************
//***********************************
class Dog
{
  // Class variables
  private int dogNum;     // Dog object number
  private String dogName; // Dog object name

  //************************
  //     setDogData()
  //************************
  public void setDogData(int aNum, String aName)
  {
     this.dogNum = aNum; 
     this.dogName = aName;
  }

  //************************
  //    method bark()
  //************************
  public void bark()
  {
     System.out.println("Arf!, Arf!");
  }

  //************************
  //  method showDogData()
  //************************
  public void showDogData()
  {
    System.out.println("My name is " + this.dogName);
	 System.out.println("I am dog number " + this.dogNum);
  }   
}

//***********************************
//***********************************
//       CLASS VirtualDog
//***********************************
//***********************************
public class VirtualDog 
{      
  public static void main(String[] args)
  {
    // Declare objects of class Dog
    Dog dog1 = new Dog();     // First object is named dog1
    Dog dog2 = new Dog();     // Second object is dog2

    // Assign names to Dog objects using setName() method
    dog1.setDogData(1, "Fido");       // dog1 name
    dog2.setDogData(2, "Maverik");    // dog2 name
   
    // Call methods of the class Dog using objects
    dog1.bark();				// dog1 barks
    dog1.showDogData();		    // dog1 says its name and
	                            // number
    dog2.showDogData();		   	// ... and so on
    dog2.bark();
   }
}





