//**********************************************************
//**********************************************************
// Program: PetStore
// Reference: Chapter 16
// Topics:
//     1. Using inheritance and abstract classes
//**********************************************************
//**********************************************************

//******************************************
//******************************************
//            CLASS Pet
//******************************************
//******************************************
abstract class Pet
{
  //********************************
  //      attributes section
  //********************************
  // Instance fields
     private String petName;
     private int petLocation;
	  private double petPrice;
 
  //*********************************
  //        methods section
  //*********************************
  // Constructor.
  // Defines the initial pet state
  public Pet(String name, int location, double price) 
  {
     this.petName = name;
     this.petLocation = location;
	 this.petPrice = price;
  }
   
  // Concrete methods in the base class 
  public void getName()
  {
     System.out.println ("Pet name: " + this.petName);
	 return;
  }
  public void getLocation()
  {
     System.out.println("Pet location: " + this.petLocation);
	 return;
  }
  public void getPrice()
  {
     System.out.println("Pet price: " + this.petPrice);
	 return;
  }

  // Abstract method
  public abstract void getSpecData();

}

//************************************
//        concrete classes
//************************************
class Dog extends Pet
{
  // Data specific for the Dog class
  String dogRace;
  int dogAge;
 
  // Constructor for the Dog class uses the constructor
  // if the super class
  public Dog(String name, int loc, double price, String race)
  {
  // Call the constructor in Pet
  super(name, loc, price);
  // Fill-in the dog-specific data
  this.dogRace = race;
  }
  
  // Concrete methods in sub class
  public void getSpecData()
  {
    System.out.println("Dog race :" + this.dogRace);
	return;
  }
}

class Cat extends Pet
{
  // Data specific for the Cat class
  String catRace;
   
  public Cat(String name, int loc, double price, String race)
  {
  // Call the constructor in Pet
  super(name, loc, price);
  // Fill-in the cat-specific data
  this.catRace = race;
  }
  
  // Concrete methods in sub class
  public void getSpecData()
  {
    System.out.println("Cat race: " + this.catRace);
	return;
  }
}

class Bird extends Pet
{
  // Data specific for the Cat class
  String birdColor;
   
  public Bird(String name, int loc, double price, String color)
  {
  // Call the constructor in Pet
  super(name, loc, price);
  // Fill-in the cat-specific data
  this.birdColor = color;
  }
  
  // Concrete methods in sub class
  public void getSpecData()
  {
    System.out.println("Bird color: " + this.birdColor);
	return;
  }
}

//******************************************
//******************************************
//             Driving class
//******************************************
//******************************************
public class PetStore
{
   
    //*****************************
    //         methods
    //*****************************
    public static void main(String[] args)  
    {

    // Create two objects of class Dog
    Dog dog1 = new Dog("Fido",2, 12.95,"Spaniel");  
    Dog dog2 = new Dog("Atila",3, 20.75,"Hound");
	
	// Create a Cat and a Bird object
	Cat cat1 = new Cat("Fifo", 3, 15.95, "Siamese");
	Bird bird1 = new Bird("Tweety", 1, 2.55, "Yellow"); 
    
	// Display pet data using super class and sub class
	// methods
	dog1.getName();     // Method in super class
	dog2.getName();     // Methods in super class
	dog2.getLocation();
	dog2.getSpecData(); // Method in sub class
	bird1.getName();
	bird1.getSpecData();
    }
}
