//***************************************************************
//   File name: SimpleInherit.java
//   Reference: Chapter 16
//***************************************************************
// Topics:
//     1. Simple inheritance
//     2. Polymorphism by method overriding
//**********************************************************
//**********************************************************

//******************************************
//******************************************
//            Employee class
//******************************************
//******************************************
class Employee
{
  //********************************
  //      attributes section
  //********************************
  // Instance fields
  private String name;
  private String address;
  private String ssn;
  private int dependants;
  private int number;
  
  // Class attribute (note the static qualifier)
  private static int consecNum = 0;
  
  //*********************************
  // methods section - constructors
  //*********************************
  // Fully parameterized constructor for Employee objects
  public Employee(String n, String a, String s, int x)
  {
     this.name = n;
     this.address = a;
     this.ssn = s;
     this.dependants = x;
     this.number = ++consecNum; // class attribute is accessed
                                // from an object method
  }

  public void showData()
  {
	 System.out.print("number: " + this.number);
     System.out.print("\tname: " + this.name);
     System.out.print("\t\taddress: " + this.address);
     System.out.print("\n\t\tSSN: " + this.ssn);
     System.out.print("\t\tdependants: " + this.dependants +
                      "\n\n");
     System.out.flush();
  }

    public void printCheck()
  {
     System.out.println("Printing check for regular employee");
  }
  
}

//******************************************
//******************************************
//        CLASS PartTimer
//******************************************
//******************************************
class PartTimer extends Employee
{
  //********************************
  //      attributes section
  //********************************
  private double hourlyWage;
  private int hoursWorked;
  
  //*********************************
  //        methods section 
  //*********************************  
  // Constructor
  public PartTimer(String n, String a, String s,
                   int x, double wage, int hours) 
  {
    // Call the constructor in the super class
    super(n, a, s, x);
    // Initialize specific fields
    this.hourlyWage = wage;
    this.hoursWorked = hours;
  }
  
  public void printCheck()
  {
     System.out.println("Printing check for part-timer");
  }
 }      
 
//******************************************
//******************************************
//             Driving class
//******************************************
//******************************************
public class SimpleInherit
{

    public static void main(String[] args)
    {
    // First two objects of Employee class are created using the
    // parameterized constructor
    Employee emp1 = new Employee("Jane", "131 Calm Street",
                                  "263", 2);
    Employee emp2 = new Employee("Jim", "42 Curve Road",
                                 "261", 6);
    
    // Following object is of class PartTimer
    PartTimer emp3 =
       new PartTimer ("Jack", "11 Bumpy St.", "333",
                       8, 11.00, 40); 
      
    // Display data using polymorphic methods
    emp1.showData();     // object of class Employee
    emp2.showData();     // object of class Employee
    emp3.showData();     // object of class PartTimer
    emp2.printCheck();   // check for object of Employee
  
	// An object of the sub class uses its own polymorphic method
    emp3.printCheck(); 

    }
}

