//**********************************************************
//**********************************************************
// Program: PetStore2
// Reference: Chapter 17
// Topics:
//     1. Class reuse through object composition
//**********************************************************
//**********************************************************

//******************************************
//******************************************
//            CLASS Pet
//******************************************
//******************************************
class Pet
{
  // Concrete methods in the base class 
  public void getName(String aName)
  {
     System.out.println ("Pet name: " + aName);
	 return;
  }
  public void getLocation(int aLocation)
  {
     System.out.println("Pet location: " + aLocation);
	 return;
  }
  public void getPrice(double aPrice)
  {
     System.out.println("Pet price: " + aPrice);
	 return;
  }
}
//************************************
//           CLASS Dog
//************************************
class Dog
{
  // Data specific for the Dog class
  private String dogName;
  private int dogLocation; 
  private double dogPrice;
  private String dogRace;
  Pet aPet = new Pet();
 
  // Constructor for the Dog class
  public Dog(String name, int loc, double price, String race)
  {
  this.dogName = name;
  this.dogLocation = loc;
  this.dogPrice = price;
  this.dogRace = race;
  }

  // Overloaded methods in the Dog class
  public void getName()
  {
     aPet.getName(this.dogName);
	 return;
  }

  public void getLocation()
  {
     aPet.getLocation(this.dogLocation);
	 return;
  }

  public void getPrice()
  {
     aPet.getPrice(this.dogPrice);
	 return;
  }

  public void getSpecData()
  {
    System.out.println("Dog race :" + this.dogRace);
	return;
  }
}

//******************************************
//******************************************
//             Driving class
//******************************************
//******************************************
public class PetStore2
{
  //*****************************
  //         methods
  //*****************************
  public static void main(String[] args)  
  {

  // Create two objects of class Dog
  Dog dog1 = new Dog("Fido",2, 12.95,"Spaniel");  
  Dog dog2 = new Dog("Atila",3, 20.75,"Hound");
  
  // Display pet data using host class and client class
  // methods
  dog1.getName();     // Method in host class
  dog2.getName();     // Method in host class
  dog2.getLocation();
  dog2.getSpecData(); // Method in client class
  }
}
