//**********************************************************
//**********************************************************
// Program: Pixels
// Reference: Chapter 17
// Topics:
//     1. Objects passed as an arguments
//     2. Methods that return objects  
//**********************************************************
//**********************************************************

//******************************************
//            Pixel class
//******************************************
class Pixel
{
   // Pixel location attributes
   private int x;       // x coordinate
   private int y;       // y coordinate
   
   // Constructor
   public Pixel(int pixX, int pixY)
   {
     this.x = pixX;
     this.y = pixY;
   }
   
   // Method to calculate the mid point between two pixels
   public static Pixel midPix(Pixel p1, Pixel p2)
   {
   int midX = (p1.x/2) + (p2.x/2);
   int midY = (p1.y/2) + (p2.y/2);
   Pixel midOne = new Pixel(midX, midY);
   return midOne;
   }
   
   // Display the address of a pixel
   public void pixLocation()
   {
     System.out.print("Pixel x : " + this.x + "  ");
     System.out.print("Pixel y : " + this.y + "\n\n");
     System.out.flush();
   }  
}
    
//******************************************
//******************************************
//             Driving class
//******************************************
//******************************************
public class Pixels
{

    public static void main(String[] args)  
    {
    // Create objects of the class Pixel
    Pixel pix1 = new Pixel(10, 50);
    Pixel pix2 = new Pixel(90, 200);
    
    // Since the method midPix is static, it is called with
    // a class reference
    Pixel pix3 = Pixel.midPix(pix1, pix2);
    
    // Display location of all three Pixel objects
    pix1.pixLocation();
    pix2.pixLocation();
    pix3.pixLocation();
   }
}
