//**********************************************************
//**********************************************************
// Program: Handler
// Reference: Chapter 19
// Topics:
//     1. Propagating exceptions along the call chain
// Requires:
//     1. Keyin class in the current directory
//**********************************************************
//**********************************************************
public class Handler
{
    public static void main(String[] args)
    {
       int dividend = 100;
       int divisor, result;
     
       divisor = Keyin.inInt("Enter divisor: ");
       try
       {
           result = PreDivide(dividend, divisor);
           System.out.println("result = " + result);
       }
       catch(DivisionException msgText)
       {
           System.out.println("In main(): " + msgText);
       }
    }
     static int PreDivide(int numerator, int denominator)
     throws DivisionException
     {
        int quotient;
        quotient = Divide(numerator, denominator);
        return quotient;
     }

     static int Divide(int x, int y)
     throws DivisionException
     {
        int value = 0;
        if(y == 0)
           throw new DivisionException("Illegal Division");
        else
           value  = x / y;
           return value;   
     }
}
//******************************
//   Exception handler class
//******************************
class DivisionException extends Exception
{
   // Parameterized constructor
   public DivisionException(String message)
   {
     super(message);
   }
}
