// Java for Engineers
// Filename: BigDSqrt
// Reference: Chapter 22
// Description:
//            Demonstration of high-precision arithmetic
//            with the BigDouble class. Program calculates the
//            square root of a floating-point number
// Requires:
//            Keyin class in current directory

import java.math.*;

class BigDSqrt 
{
   public static void main(String[] args)
   {
        double value = 1.0;
        String numS;
        int scale = 30;
        BigDecimal v;
  
        System.out.println("Big decimal square root routine\n");
        numS = Keyin.inString("Enter value: ");
        scale = Keyin.inInt("Enter scale: ");

        // Convert value to big decimal format
        v = new BigDecimal(numS);
        System.out.println(sqrt(v, scale));
    }

   public static BigDecimal sqrt(BigDecimal n, int s)
   {
        BigDecimal TWO = BigDecimal.valueOf(2);

        // Obtain the first approximation
        BigDecimal x = n.divide(BigDecimal.valueOf(3), s,
          BigDecimal.ROUND_DOWN);
        BigDecimal lastX = BigDecimal.valueOf(0);

         // Proceed through 50 iterations 
        for (int i=0; i<50; i++)
        {
          x = n.add(x.multiply(x)).divide(x.multiply(TWO), s,
              BigDecimal.ROUND_DOWN);
          if (x.compareTo(lastX) == 0)
              break;
       lastX = x;
     }
    return x;
  }
}


