//**********************************************************
//**********************************************************
// Project: Java for Engineers
// Program: Closeable.java
// Reference: Chapter 26
// Topics:
//     1. Extending the java Frame class with ActiveFrame.
//        ActiveFrame provides additional processing logic
//        for closing the program window without having to
//        re-boot.
//     2. Calling methods in the super classes
//     3. Displaying the frame using the show() method of
//        the Window class
//**********************************************************
// Requires:
//     1. ActiveFrame class in the current directory
//**********************************************************
//**********************************************************

import java.awt.*;
import ActiveFrame;

//*********************************************
//*********************************************
//              driving class
//*********************************************
//*********************************************

public class Closeable extends ActiveFrame
{
// By extending ActiveFrame we make accessible all its 
// methods and those of its superclasses (Object, Component,
// Container, Window, and Frame).
//****************************
//          main
//****************************
public static void main(String[] args)
{
   // Create an object of the class GFrame. We can use
   // this object to access the methods in GFrame and 
   // its super classes
	 
   Closeable aframe = new Closeable();
     
   // Use methods in the Component class
   // to modify object's default dimensions and screen
   // and the setTitle() method of the Frame class to change
   // the window title
   aframe.setSize(400, 300);             // Set frame size
   aframe.setLocation(200, 100);         // Set frame location
   aframe.setTitle("Closeable Frame Demo");  // Titlebar text
     
   // Display the frame using the show() method of the Window
	// class
   aframe.show();
   }
}
   