//**********************************************************
//**********************************************************
// Project: Java for Engineers
// Program: Text.java
// Reference: Chapter 26
// Topics:
//       1. Instantiating a Graphics object
//       2. Redefining the paint() method
//       3. Changing fonts
//       4. Displaying a text message
//**********************************************************
//**********************************************************
// Requires:
//     1. ActiveFrame class in the current directory
//**********************************************************
//**********************************************************

import java.awt.*;

//*********************************************
//*********************************************
//              driving class
//*********************************************
//*********************************************

public class Text extends ActiveFrame
{
   //*********************************
   //      redefinition of paint()
   //*********************************
   // The paint() method of the Java AWT Canvas class
   // fills the Window's client area with the default
   // color. An application can redefine paint() in
   // order to output graphics to the display.
   // The following code redefines paint(), which receives
   // a Graphics object as a parameter, and then uses
   // the drawString method of the Graphics class to
   // display a message on the screen.
      
   public void paint(Graphics g)
   {
     // Define a monospaced, bold, 16-point font
     Font f = new Font("Monospaced", Font.BOLD, 16);
     // Set the font in the device context
     g.setFont(f);
     // Display a text string
     g.drawString("Hello Engineers, this is Java", 50,
                   100);
   }

   //****************************
   //          main
   //****************************
   public static void main(String[] args)
   {
     // Create an object of the class WindowText
     Text aframe = new Text();
     
     // Use methods in superclasses to modify object's default
     // size, location, and program title
     aframe.setSize(500, 300);             // Set frame size
     aframe.setLocation(200, 100);         // Set frame location
     aframe.setTitle("Text Demo Program"); // Titlebar text
     
     // Display frame calling the show() method of the Window
     // class
     aframe.show();
     
   }
}   